﻿# CMA - CheeTaHs Map Adverts
## ..addons/eventscripts/cma/cma.py

# Special thanks to L'in20cible for helping me with creating decals! (:

import es
import playerlib

FilesToPrecacheAndDownload = []
FilesToDraw = []
PlayersThatSeesDecals = []

for LINE in open(es.getAddonPath("cma").replace("\\addons", "\\cfg").replace("/addons", "/cfg")+'/map_adverts.txt').readlines():
    if not LINE.lower().startswith("|addadvert|"):
        continue
    LINE = LINE.replace('\\','/')
    LINES = LINE.split("|")
    FilesToPrecacheAndDownload.append('materials/'+LINES[6])
    FilesToDraw.append("%s|%s|%s|%s|%s" %(LINES[2],LINES[3],LINES[4],LINES[5],LINES[6]))


def load():
    DownAndPrecache()
    for players in playerlib.getUseridList("#all"):
        PlayersThatSeesDecals.append(str(players))

def es_map_start(ev):
    DownAndPrecache()

def player_spawn(ev):
    if ev['userid'] not in PlayersThatSeesDecals:
        if int(ev['es_userteam']) > 0:
            PlayersThatSeesDecals.append(ev['userid'])
            DrawDecals()
        
        
def player_say(ev):
    if ev['text'].lower() != '!pow':
        return
    x, y, z = playerlib.getPlayer(ev['userid']).getViewCoord().split(",")
    es.tell(ev['userid'],'#multi','#default|#greenAddAdvert#default|#green%s#default|#green%s#default|#green%s#default|#green%s#default|#greenMaterial#default|#green' %(es.ServerVar("eventscripts_currentmap"),x,y,z))
    
def DownAndPrecache():
    PubVarVersion = "1.0CheeTaH-Public"
    PubVar = es.ServerVar("cma_version",PubVarVersion,"Script Version")
    PubVar.set(PubVarVersion)
    PubVar.makepublic()
    for TEXTURE in FilesToPrecacheAndDownload:
        es.precachedecal(TEXTURE)
        es.stringtable('downloadables', TEXTURE)
    DrawDecals()
    
def DrawDecals():
    CurrentMap = str(es.ServerVar("eventscripts_currentmap")).lower()
    for LINE in FilesToDraw:
        LINES = LINE.split("|")
        if LINES[0].lower () == CurrentMap:
            index = es.createentity('infodecal')
            es.entitysetvalue(index, 'texture', LINES[4])
            es.entitysetvalue(index, 'origin', '%s %s %s' % (LINES[1],LINES[2],LINES[3]))
    es.fire(es.getuserid(), 'infodecal', 'Activate')